      SUBROUTINE READWILLISTABLES(ntypemax,nyearmax,xcorr,
     * filein,ntyp,iyearmin,iyearmax)

C     READWILLISTABLES READS WIJFFELS TABLE 2 INFORMATION
C     (WILLIS CORRECTIONS)

      parameter (icmax=5,maxyear=3000)
      character*80 filein,filename,text
      dimension icomma(icmax,2),xcorr(nyearmax,ntypemax,0:12)
      dimension iyearmin(ntypemax),iyearmax(ntypemax) 
      call extraname('sys.inf'//CHAR(0),filein,filename)

      open(10,file=filename,status='old')

      iyearmin(ntyp)=maxyear
      read(10,'(a)') text
      do 50 iy=1,maxyear
       call clearstring(text,80)

       read(10,'(a)',end=4) text
       call findlastchar(nsp,text,80)
       call spacefindl(nsp,icmax,ncomma,icomma,text)

       read(text(icomma(1,1):icomma(1,1)+icomma(1,2)-1),*) inyear
       read(text(icomma(2,1):icomma(2,1)+icomma(2,2)-1),*,
     * end=50,err=50) xcorr0

       if ( iyearmin(ntyp) .eq. maxyear ) iyearmin(ntyp)=inyear
       iyearmax(ntyp)=inyear

       xcorr(inyear,ntyp,0)=xcorr0

50    continue
4     continue

      close(10)

      do 60 iy=iyearmin(ntyp),iyearmax(ntyp)-1
       xdiff=(xcorr(iy+1,ntyp,0)-xcorr(iy,ntyp,0))/12.

       do 65 mon=1,12
        xmon=mon
        xcorr(iy,ntyp,mon)=xcorr(iy,ntyp,0)+((xmon-1)*xdiff)
65     continue

60    continue

      do 75 mon=1,12
       xcorr(iyearmax(ntyp),ntyp,mon)=xcorr(iyearmax(ntyp),ntyp,0)
75    continue

      return
      end 
